org.cpsolver.ifs.assignment.context

## Interface AssignmentContextHolder<V extends Variable<V,T>,T extends Value<V,T>>

- Type Parameters:
    `V` - Variable
    `T` - Value
  All Known Implementing Classes:
    AssignmentContextHolderArray, AssignmentContextHolderMap, DefaultParallelAssignmentContextHolder, DefaultSingleAssignmentContextHolder, InheritedAssignmentContextHolder

      public interface AssignmentContextHolder<V extends Variable<V,T>,T extends Value<V,T>>

  An interface holding all assignment contexts associated with one assignment. It also creates a new assignment context when there is no assignment context associated with the given reference.
  Method `AssignmentContextReference.getIndex()` can be used to index stored contexts. A new assignment context can be created for a reference by calling `HasAssignmentContext.createAssignmentContext(Assignment)` on the `AssignmentContextReference.getParent()`.
  Version:
    IFS 1.3 (Iterative Forward Search)
    Copyright (C) 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses.
  Author:
    Tomáš Müller
  See Also:
    `AssignmentContext`, `AssignmentContextReference`, `HasAssignmentContext`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `<U extends AssignmentContext> void` | `clearContext(AssignmentContextReference<V,T,U> reference)` Clear an assignment context that is associated with the given a reference.
    `<U extends AssignmentContext> U` | `getAssignmentContext(Assignment<V,T> assignment, AssignmentContextReference<V,T,U> reference)` Return assignment context for the given assignment and reference.

- - ### Method Detail

    - #### getAssignmentContext

          <U extends AssignmentContext> U getAssignmentContext(Assignment<V,T> assignment,
                                                               AssignmentContextReference<V,T,U> reference)

      Return assignment context for the given assignment and reference. A new assignment context is created when there is not assignment context associated with the given reference yet.
      Type Parameters:
        `U` - assignment context type
      Parameters:
        `assignment` - current assignment (there is only one assignment associated with one holder, but the assignment is passed so that `HasAssignmentContext.createAssignmentContext(Assignment)` can be called if needed
        `reference` - a reference created by calling `Model.createReference(HasAssignmentContext)`
      Returns:
        an assignment context

    - #### clearContext

          <U extends AssignmentContext> void clearContext(AssignmentContextReference<V,T,U> reference)

      Clear an assignment context that is associated with the given a reference. If there is any created for the reference.
      Type Parameters:
        `U` - assignment context type
      Parameters:
        `reference` - a reference (which can be stored within the model, e.g., as an instance variable of a constraint)